Opened 12 years ago

Last modified 12 years ago

#3256 closed Bug report

Timezone conversion error - incorrect year

Reported by: rkodey Owned by:
Priority: normal Component: Other
Keywords: Cc: rkodey, Tim Kosse, Alexander Schuch
Component version: Operating system type:
Operating system version:

Description

This is a fresh look at bug 1608370 (which was closed as it was mis-categorized as a server bug)
In my case it's solely a Client bug (FileZilla Client 3.0.1)

The issue is definitely related to timezones. When a file is uploaded to a FTP server between midnight local time and midnight GMT, the file's year is decremented. (At least that is the case for those of us that are X hours behind GMT time.)

In my case, I'm GMT -0400 - so the error only shows itself for the 4 hours between midnight GMT and midnight EST.

Here's snapshot #1: I'm uploading a fresh file 11:03pm Eastern on 9/24 (aka GMT 03:03 9/25)

Response: 220 ProFTPD 1.3.0a Server
Command: SYST
Response: 215 UNIX Type: L8
Command: LIST -a
Response: 150 Opening ASCII mode data connection for file list
Listing: drwxr-x--x 2 user1103899 user1103899 4096 Sep 25 03:03 .
Listing: drwxr-x--x 8 user1103899 user1103899 4096 Apr 18 17:39 ..
Listing: -rw-r--r-- 1 user1103899 user1103899 1362 Sep 25 03:03 cache.xml
Response: 226 Transfer complete.
Status: Directory listing successful

The resulting "Last Modified" date shown in FileZilla Client is:
cache.xml 9/24/2006 11:03:00 PM

So, notice the YEAR is off by 1. However, it's done the timezone conversion properly for the time, and day of the month.

I'll do another snapshot just past midnight, so you can see the exact same file correct itself in the Client.

Change History (11)

comment:1 Changed 12 years ago by rkodey

...and now the EXACT same directory listing - I have made no changes

The raw listing is exactly the same:

Command: LIST -a
Response: 150 Opening ASCII mode data connection for file list
Listing: drwxr-x--x 2 user1103899 user1103899 4096 Sep 25 03:03 .
Listing: drwxr-x--x 8 user1103899 user1103899 4096 Apr 18 17:39 ..
Listing: -rw-r--r-- 1 user1103899 user1103899 1362 Sep 25 03:03 cache.xml
Response: 226 Transfer complete.
Status: Directory listing successful

...however, now FileZilla Client shows a "Last Modified" date of:
cache.xml 9/24/2007 11:03:00 PM

The year has magically updated itself to the correct year. It appears that when localtime and GMT span 2 different days, the year is being incorrectly decremented.

comment:2 Changed 12 years ago by rkodey

Woops - submitted too early.

The only difference between my initial bug description that shows the incorrect year, and my second comment where the year is correct - is that I simply waited until after midnight localtime.

Thus, when localtime and GMT are on the same day, all is fine. When localtime and GMT span 2 days, the year is incorrect.

comment:3 Changed 12 years ago by Tim Kosse

Thanks for reporting. This issue has been fixed in the SVN
repository and will be available with the next version.

comment:4 Changed 12 years ago by Tim Kosse

Please try most recent nightly from http://filezilla-project.org/nightly.php

comment:5 Changed 12 years ago by rkodey

Hi - Sorry for the delayed response. I just tried the 2007-10-04 nightly, and I'm still seeing the problem.

I uploaded a fresh copy of a test file, which you'll see in the listing below. My local time (Eastern/US -0400) is 11:39pm Oct 4. Note the resulting file's UTC time of Oct 5 03:39 on the FTP server (which is correct).

However, FileZilla (3.0.1-nightly) client still shows 10/4/2006 11:39:00 PM - off by 1 year still.

Let me know if I can provide any further info.

Status: Retrieving directory listing...
Command: LIST -a
Response: 150 Opening ASCII mode data connection for file list
Listing: drwxr-x--x 2 user1103899 user1103899 4096 Oct 5 03:39 .
Listing: drwxr-x--x 8 user1103899 user1103899 4096 Apr 18 17:39 ..
Listing: -rw-r--r-- 1 user1103899 user1103899 1362 Oct 5 03:39 cache.xml
Response: 226 Transfer complete.
Status: Directory listing successful

comment:6 Changed 12 years ago by Tim Kosse

Oops, I've accidentally corrected into the wrong direction. Please try the 2007-10-06 nightly.

comment:7 Changed 12 years ago by rkodey

ok - will do. Just for clarification, though - there appeared to be no change at all with the 2007-10-04 build. Meaning, I did not observe "corrected into the wrong direction" - the year was the same as observed in the actual 3.0.1 build.

comment:8 Changed 12 years ago by Tim Kosse

The cut-off date got moved into the wrong direction, that's why you didn't see a change.

comment:9 Changed 12 years ago by rkodey

Just tried the 2007-10-06 nightly - no change. Same problem exists.

comment:10 Changed 12 years ago by Tim Kosse

Made a typo, please try next nightly.

comment:11 Changed 12 years ago by rkodey

Bingo - that's got it fixed. Thanks!

Note: See TracTickets for help on using tickets.